/*
 dcaration multiple 0.1 - LYNX - kit BLL (newcc65)
 Travail graphique et sonore avec SmpStart(ola, 0);
 20/05/2012
 LYNX-image */
#include <stdlib.h>
#include <lynx.h>
#include <lynxlib.h>

#include "ola.h"


/* LYNX-specific #defines: */
#define JOY_RIGHT		0x10
#define JOY_LEFT		0x20
#define JOY_DOWN		0x40
#define JOY_UP			0x80

#define BUTTON_OPTION1	0x08
#define BUTTON_OPTION2	0x04
#define BUTTON_LEFT		0x02
#define BUTTON_RIGHT	0x01

#define BUTTON_PAUSE	0x01

#define	BUFFER1	0x9000

char SCREEN[8160]       at (MEMTOP-16320);
char RENDER[8160]       at (MEMTOP-8160);

char pal[]={
	0x00,0x00,0x05,0x0F,0x0C,0x01,0x03,0x07,0x05,0x03,0x0F,0x08,0x0F,0x04,0x0F,0x00,
	0xFF,0x00,0x55,0xFF,0xBF,0x1D,0x5F,0xAF,0xC0,0x61,0x00,0x00,0x0F,0x0F,0xA0,0xFA};


// ------------------------------------
/*****************************************************************************
**  Ci-dessous, le contenu du fichier batchfile pour l'image mascot.bmp   **
                                                                            **
set image01=mascot.bmp

SPRPCK -t6 -S048048 -a012012 -p0 %image01%
cmd
**  Le point d'action de l'image elvballp est mis au centre de celle-ci,    **
**  (-a012012)                                                              **
*****************************************************************************/
// 26 sprites
// on a besoin de stdlib pour bcopy() de mmoire. 84 correspond  la taille mmoire allou aux sprites, soit ici SCB[25][84] ---->   25 (0  25) soit 26 sprites de 84 octets chacun. 198
extern char SCB[25][11] at (0xfff8-16320-25*11);

// spr0 est le "modle" de sprite de 11 octet pour initialiser une occurence de SCB2[]
extern char spr0[11];

// init_scb est le premier sprite  afficher, en fait, il pointe sur un sprite vide
// j'aurais aussi pu le faire pointer vers le background
// l'important dans le _init_scb, c'est dc.w _SCB2
// qui fait pointer le sprite suivant vers le premier du tableau SCB
extern char init_scb[23];

#asm
; init_scb est utilis pour initialiser les registres du SpriteEngine
; avec les paramtres adquats (palette...)
; Using this trick, the 8*11 spr[]-SCBs only need 11 Bytes each!
_init_scb:
		dc.b $c1, $10, $20
		dc.w _SCB ; PTR_NEXT pointe vers le 1 sprite visible (SCB[0])
		dc.w dummy ; PTR_DATA pointe vers un sprite "inexistant"
		dc.w 200, 200 ; x,y -> on affiche en dehors de l'cran
		dc.w $100, $100 ; pas de zoom
		dc.b $01, $23, $45, $67, $89, $ab, $cd, $ef

dummy: dc.b 0,0,0 ; le sprite "inexistant"

; spr0 sert de modle au sprites du tableau SCB
_spr0: dc.b $c4, $08, $02 ; CTL0, CTL1 = rutilise la palette, COLL
		dc.w 0, 0
		dc.w 0, 0
#endasm







extern uchar mascot[]; // image mascot

uchar SCBe[];

#asm         
_SCBe      dc.b $c0,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
#endasm
// ------------------------------------



// ------------------------------------
// clip du sprite chiffres, chacun d'une taille de 8*8: 0123456789.LEV
extern uchar bc000000[];
extern uchar bc000001[];
extern uchar bc000002[];
extern uchar bc000003[];
extern uchar bc000004[];
extern uchar bc000005[];
extern uchar bc000006[];
extern uchar bc000007[];
extern uchar bc000008[];
extern uchar bc000009[];
extern uchar bc000010[];
extern uchar bc000011[];
extern uchar bc000012[];
extern uchar bc000013[];

uchar *chiffrestab[14] = {bc000000, bc000001, bc000002, bc000003, bc000004,
                         bc000005, bc000006, bc000007, bc000008, bc000009,
                         bc000010, bc000011, bc000012, bc000013};

// ------------------------------------
// clip du sprite chiffres, chacun d'une taille de 8*8: 0123456789.LEV
extern uchar tm000000[];
extern uchar tm000001[];
extern uchar tm000002[];
extern uchar tm000003[];
extern uchar tm000004[];
extern uchar tm000005[];
extern uchar tm000006[];
extern uchar tm000007[];
extern uchar tm000008[];
extern uchar tm000009[];


uchar *tmtab[10] = {tm000000, tm000001, tm000002, tm000003, tm000004,
                         tm000005, tm000006, tm000007, tm000008, tm000009};
// ------------------------------------



int posx,posy,scaelv,etape;
int i,ihrotation,ivrotation,relachleft,relachright;
char choix,tempa,tempb,tempc,tempd,arfs;

// assembler vertical retrace syncronisation routine
void Vsync() 
{
#asm
vretrace:
	lda $fd0a
	bne vretrace
#endasm
}


void init_sprites()
{
	char i1;

	for (i1 = 0; i1 < 25; i1++)
		{
		bcopy(&spr0[0], &SCB[i1][0], 11);//198);//84);//11);
		SCBX(&SCB[i1][0]) = 0;
		SCBY(&SCB[i1][0]) = 0;
		//SCBDATA(&SCB[i1][0])  = chiffrestab[0%14]; // 
		SCBDATA(&SCB[i1][0])  = tmtab[0%10]; // 
		SCBNEXT(&SCB[i1][0]) = &SCB[i1+1][0];
		}
	SCBNEXT(&SCB[24][0]) = 0;//SCBe;//0;
}


/**************************************************************************
**                                                                       **
**                                                                       **
**************************************************************************/
char main()
{
  InitIRQ();
  CLI;

  SetBuffers(SCREEN, RENDER ,0);

  /* set the palette */
  SetRGB(pal); //  Ceci sert  changer la palette de la Lynx. 
  //DrawFBox(0,0,160,102,0);
  posx=16;  
  posy=10;  

//  if (arfs==0)
//		{
		init_sprites();
//		arfs=1;
//		}  
  
//  SCBNEXT(&SCB[24][0])= SCBe; // marche pas !

  SCBDATA(SCBe) = mascot;

  SCBNEXT(SCBe) = (&SCB[0][0]);//SCBchiffres1; // chainage score unit
  


  
  scaelv=1024; // echelle de l'image mascot (taille originelle = 256)
  
// bruitage
	SetBuffers(BUFFER1,0,0);
	SmpInit(0,1);
	EnableIRQ(1);

/**************************************************************************
**                       BOUCLE PRINCIPALE                               **
**************************************************************************/    
  
  //for( ; ; )
  while(1)
{

  //DrawFBox(0,0,160,102,0); // affichage d'une boite couleur 0 (noire)

 if (joystick & JOY_RIGHT) // direction Droite
  posx++;
 if (joystick & JOY_LEFT) // direction Gauche
  posx--; 
 if (joystick & JOY_UP) // direction Haut
  posy--; 
 if (joystick & JOY_DOWN) // direction Bas
  posy++; 

  if (posx>152) posx=152;   // limit va  gauche
  if (posx<0) posx=0;    // limit va  gauche
  if (posy<0) posy=0;    // limit haut
  if (posy>94) posy=94;   // limit bas

/**************************************************************************
**************************************************************************/ 
	if (joystick & BUTTON_OPTION1)
		{
		scaelv=1024; 
		posx=160/2;posy=102/2;
		etape=0;
		}

	if (joystick & JOY_RIGHT)
		{
		posx++; // direction Droite
		if (posx>158)		posx=158;
		}
	if (joystick & JOY_LEFT)
		{
		posx--;  // direction Gauche
		if (posx<2)		posx=2; 
		}
	if (joystick & JOY_UP)
		{
		posy--; // direction Haut
		if (posy<-2)		posy=-2;
		}
	if (joystick & JOY_DOWN)
		{
		posy++; // direction Bas
		if (posy>100)		posy=100;  
		}
	
	
	if (etape==0) 
		{
		if (scaelv>64)
			{
			scaelv-=2;//scaelv=scaelv-2;
			if (scaelv<65)		{scaelv=64;etape=1;}
			}
		}
	if (etape==1) 
		{
		if (scaelv<256)
			{
			scaelv+=2;//scaelv=scaelv+2;
			if (scaelv>255)		{scaelv=256;etape=0;}
			}
		}


	if (relachleft==1)
		{
		if (!(joystick & BUTTON_LEFT))	{relachleft=0;}
		}
	if (relachleft==0)
		{
		if (joystick & BUTTON_LEFT)
			{
			++ihrotation;relachleft=1;
			if (ihrotation==3)	ihrotation=1;
			if (ihrotation==1)
				{
//				SCBe[0] = 0xd0;  // Determine quadrant --> horizontal  l'envers
				}
			if (ihrotation==2)
				{
//				SCBe[0] = 0xc0;  // Determine quadrant --> horizontal  l'endroit 
				}
			}
		}

	if (relachright==1)
		{
		if (!(joystick & BUTTON_RIGHT))	{relachright=0;}
		}
	if (relachright==0)
		{
		if (joystick & BUTTON_RIGHT)
			{
			++ivrotation;relachright=1;
			if (ivrotation==3)	ivrotation=1;
			if (ivrotation==1)
				{
//				SCBe[0] = 0xe0;  // Determine quadrant --> vertical  l'envers
				}
			if (ivrotation==2)
				{
//				SCBe[0] = 0xf0;  // Determine quadrant --> vertical  l'endroit 
				}
			}
		}

/****************************************************************************************************************************************************/
	

	
	
	

		
SCBX(&SCB[1][0]) = 16;//SCBY(&SCB[1][0]) = 0;
SCBX(&SCB[2][0]) = 32;

SCBDATA(&SCB[1][0])  = tmtab[1%10]; // 
SCBDATA(&SCB[2][0])  = tmtab[2%10]; // 

//DrawSprite(&SCB[23][0]);//(SCB);

//DrawSprite(SCB);



	SCBX(SCBe) = posx;SCBY(SCBe) = posy;
//	SCBHS(SCBe) = scaelv;SCBVS(SCBe) = scaelv; // taille image originelle = 256
	DrawSprite(SCBe);
//	DrawSprite(&SCB[24][0]);
  

	



	Vsync();
if (tempa>0)	--tempa;
if (tempa==0)
	{
	if(joystick & BUTTON_OPTION2)   
		{
		tempa=100;
		SmpStart(ola, 0);
		}
	}
	SwapBuffers();
}
  
/**************************************************************************
**                     FIN de la BOUCLE PRINCIPALE                       **
**************************************************************************/   
  
 }

 