/*
 dcaration multiple 0.1 - LYNX - kit BLL (newcc65)
 Travail graphique et sonore avec SmpStart(ola, 0);
 23/05/2012
 LYNX-image */
#include <stdlib.h>
#include <lynx.h>
#include <lynxlib.h>

#include "ola.h"


/* LYNX-specific #defines: */
#define JOY_RIGHT		0x10
#define JOY_LEFT		0x20
#define JOY_DOWN		0x40
#define JOY_UP			0x80

#define BUTTON_OPTION1	0x08
#define BUTTON_OPTION2	0x04
#define BUTTON_LEFT		0x02
#define BUTTON_RIGHT	0x01

#define BUTTON_PAUSE	0x01

#define	BUFFER1	0x9000

char SCREEN[8160]       at (MEMTOP-16320);
char RENDER[8160]       at (MEMTOP-8160);

char pal[]={
	0x00,0x00,0x05,0x0F,0x05,0x0A,0x00,0x0B,0x09,0x06,0x06,0x0A,0x0C,0x0E,0x04,0x01,
	0xFF,0x00,0x55,0xFF,0x00,0x67,0x0F,0xCF,0x9F,0x5F,0x0F,0x0F,0xAF,0xCF,0x0E,0x0A};
	
// ------------------------------------
/*****************************************************************************
**  Ci-dessous, le contenu du fichier batchfile pour l'image mascot.bmp   **
                                                                            **
set image01=mascot.bmp

SPRPCK -t6 -S064064 -a032032 -p0 %image01%
cmd
**  Le point d'action de l'image elvballp est mis au centre de celle-ci,    **
**  (-a024024)                                                              **
*****************************************************************************/
// 56 sprites 8*7 = 56
// on a besoin de stdlib pour bcopy() de mmoire. 84 correspond  la taille mmoire allou aux sprites, soit ici SCB[25][84] ---->   25 (0  25) soit 26 sprites de 84 octets chacun. 198
//extern char SCB[25][11] at (0xfff8-16320-25*11);
extern char SCB[56][11] at (0xfff8-16320-56*11);

// spr0 est le "modle" de sprite de 11 octet pour initialiser une occurence de SCB2[]
extern char spr0[11];

// init_scb est le premier sprite  afficher, en fait, il pointe sur un sprite vide
// j'aurais aussi pu le faire pointer vers le background
// l'important dans le _init_scb, c'est dc.w _SCB2
// qui fait pointer le sprite suivant vers le premier du tableau SCB
extern char init_scb[23];

#asm
; init_scb est utilis pour initialiser les registres du SpriteEngine
; avec les paramtres adquats (palette...)
; Using this trick, the 8*11 spr[]-SCBs only need 11 Bytes each!
_init_scb:
		dc.b $c1, $10, $20
		dc.w _SCB ; PTR_NEXT pointe vers le 1 sprite visible (SCB[0])
		dc.w dummy ; PTR_DATA pointe vers un sprite "inexistant"
		dc.w 200, 200 ; x,y -> on affiche en dehors de l'cran
		dc.w $100, $100 ; pas de zoom
		dc.b $01, $23, $45, $67, $89, $ab, $cd, $ef

dummy: dc.b 0,0,0 ; le sprite "inexistant"

; spr0 sert de modle au sprites du tableau SCB
_spr0: dc.b $c4, $08, $02 ; CTL0, CTL1 = rutilise la palette, COLL
		dc.w 0, 0
		dc.w 0, 0
#endasm







extern uchar mascot[]; // image mascot

uchar SCBm[];

#asm         
_SCBm      dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
#endasm
// ------------------------------------



// ------------------------------------
// clip du sprite chiffres, chacun d'une taille de 8*8: 0123456789.LEV
extern uchar bc000000[];
extern uchar bc000001[];
extern uchar bc000002[];
extern uchar bc000003[];
extern uchar bc000004[];
extern uchar bc000005[];
extern uchar bc000006[];
extern uchar bc000007[];
extern uchar bc000008[];
extern uchar bc000009[];
extern uchar bc000010[];
extern uchar bc000011[];
extern uchar bc000012[];
extern uchar bc000013[];

uchar *chiffrestab[14] = {bc000000, bc000001, bc000002, bc000003, bc000004,
                         bc000005, bc000006, bc000007, bc000008, bc000009,
                         bc000010, bc000011, bc000012, bc000013};

						 
						 
// ------------------------------------

uchar SCBchiffres1[]; // dclaration d'un nouveau controleur de sprite (test)
uchar SCBchiffres2[]; // dclaration d'un nouveau controleur de sprite (test)
uchar SCBchiffres3[]; // dclaration d'un nouveau controleur de sprite (test)
uchar SCBchiffres4[]; // dclaration d'un nouveau controleur de sprite (test)
#asm
_SCBchiffres1     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
;
_SCBchiffres2     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
;
_SCBchiffres3     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
;
_SCBchiffres4     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          dc.b $01,$23,$45,$67,$89,$ab,$cd,$ef
#endasm
// ------------------------------------
 
// ------------------------------------
// clip de 10 sprites tm (de 0  9), chacun d'une taille de 16*16
extern uchar tm000000[];
extern uchar tm000001[];
extern uchar tm000002[];
extern uchar tm000003[];
extern uchar tm000004[];
extern uchar tm000005[];
extern uchar tm000006[];
extern uchar tm000007[];
extern uchar tm000008[];
extern uchar tm000009[];


uchar *tmtab[10] = {tm000000, tm000001, tm000002, tm000003, tm000004,
                         tm000005, tm000006, tm000007, tm000008, tm000009};
// ------------------------------------



int posx,posy,scaelv,etape,level,pointx,pointy,tile_x, col_x;
int i,ihrotation,ivrotation,relachleft,relachright;
int compti, comptx, compty, brnbr, lecx;
char choix,tempa,tempb,tempc,tempd,arfs;

int atest,unite,dizaine,centaine,millier,dizmill,horszone;

#include "rz.h"

// assembler vertical retrace syncronisation routine
void Vsync() 
{
#asm
vretrace:
	lda $fd0a
	bne vretrace
#endasm
};


void init_sprites()
{
	char i1;

	//for (i1 = 0; i1 < 25; i1++) // 0  24 = 25
	//for (i1 = 0; i1 < 70; i1++) // 0  69 = 70
	for (i1 = 0; i1 < 56; i1++) // 0  55 = 56
		{
		bcopy(&spr0[0], &SCB[i1][0], 11);//198);//84);//11);
		SCBX(&SCB[i1][0]) = 0;
		SCBY(&SCB[i1][0]) = 0;
		//SCBDATA(&SCB[i1][0])  = chiffrestab[0%14]; // 
		SCBDATA(&SCB[i1][0])  = tmtab[0%10]; // 
		SCBNEXT(&SCB[i1][0]) = &SCB[i1+1][0];
		}
	//SCBNEXT(&SCB[24][0]) = 0;
	//SCBNEXT(&SCB[69][0]) = 0;
	SCBNEXT(&SCB[55][0]) = 0;
};
// 8
// [ligne] [colonne]
//uchar tbr01[7][8]=
uchar tbr01[7][56]=
{
	{1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8},
	{1,0,0,0,0,0,0,8,1,1,1,1,1,1,1,8,2,2,2,2,2,2,2,8,3,3,3,3,3,3,3,8,4,4,4,4,4,4,4,8,5,5,5,5,5,5,5,8,6,6,6,6,6,6,6,8},
	{1,0,0,0,0,0,0,8,1,1,1,1,1,1,1,8,2,2,2,2,2,2,2,8,3,3,3,3,3,3,3,8,4,4,4,4,4,4,4,8,5,5,5,5,5,5,5,8,6,6,6,6,6,6,6,8},
	{1,0,0,0,0,0,0,8,1,1,1,1,1,1,1,8,2,2,2,2,2,2,2,8,3,3,3,3,3,3,3,8,4,4,4,4,4,4,4,8,5,5,5,5,5,5,5,8,6,6,6,6,6,6,6,8},
	{1,0,0,0,0,0,0,8,1,1,1,1,1,1,1,8,2,2,2,2,2,2,2,8,3,3,3,3,3,3,3,8,4,4,4,4,4,4,4,8,5,5,5,5,5,5,5,8,6,6,6,6,6,6,6,8},
	{1,0,0,0,0,0,0,8,1,1,1,1,1,1,1,8,2,2,2,2,2,2,2,8,3,3,3,3,3,3,3,8,4,4,4,4,4,4,4,8,5,5,5,5,5,5,5,8,6,6,6,6,6,6,6,8},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7}
};
uchar tbr02[7][48]=
{
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6},
	{1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6}
};
/**************************************************************************
**                                                                       **
**                                                                       **
**************************************************************************/
char main()
{
  InitIRQ();
  CLI;

  SetBuffers(SCREEN, RENDER ,0);

  /* set the palette */
  SetRGB(pal); //  Ceci sert  changer la palette de la Lynx. 
  //DrawFBox(0,0,160,102,0);


//  if (arfs==0)
//		{
		init_sprites();
//		arfs=1;
//		}  
  
  SCBNEXT(&SCB[55][0])= SCBm; // lier sprite mascote  tout les sprites dj chains... a marche !

  SCBDATA(SCBm) = mascot;


// 2me sprite chain (test)
  SCBNEXT(SCBm) = SCBchiffres1;

  SCBNEXT(SCBchiffres1) = SCBchiffres2; // chainage de sprite

  SCBNEXT(SCBchiffres2) = SCBchiffres3; // chainage de sprite

  SCBNEXT(SCBchiffres3) = SCBchiffres4; // chainage de sprite




	
// bruitage
	SetBuffers(BUFFER1,0,0);
	SmpInit(0,1);
	EnableIRQ(1);

/**************************************************************************
**                       BOUCLE PRINCIPALE                               **
**************************************************************************/    
miseazero();

SwapBuffers();
Vsync();

  //for( ; ; )
  while(1)
{

  //DrawFBox(0,0,160,102,0); // affichage d'une boite couleur 0 (noire)

/**************************************************************************
**************************************************************************/ 

// [ligne] [colonne]
//uchar tbr01[7][8]=
	
if (etape==1) 
	{
	++etape;
	if (level==1) // lecture data pour les Tiles du dcor.
		{
		//for(comptx=0 ; comptx<10; comptx++) // de 0  9, ce qui fait 10
		for(comptx=0 ; comptx<8; comptx++) // de 0  7, ce qui fait 8
			{
			compty=0;
			for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
				{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
				if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
					{
					SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
					SCBX(&SCB[brnbr][0]) = comptx*24;//16;
					SCBY(&SCB[brnbr][0]) = compty*24;//16;
					++brnbr; 
					}
				}
			}
		//atest=brnbr;
		brnbr=0;
		}
	}

if (etape==2) // jeu !
	{

	
	if (joystick & BUTTON_OPTION1)
		{
		miseazero();
		}

//	if (joystick & JOY_RIGHT)
//		{
//		posx+=2; // direction Droite
//		if (posx>192)		posx=192; // limit va  droite
//		}
	//if (posx>82 & 
	if (joystick & JOY_RIGHT)
		{
		//if (pointx<32+24+24+24+24+24+24+24+24+24)
		if (pointx<608+192+192+192)//248+96+24+24+24)
			{
			pointx+=2;
			SCBX(SCBchiffres1) +=2;SCBX(SCBchiffres2) +=2;SCBX(SCBchiffres3) +=2;SCBX(SCBchiffres4) +=2;
		
			col_x+=2;
			if (col_x>23)
				{
				col_x=0;tile_x+=1;
			
			
//			if (tile_x==2)
//				{
//				comptx=8;brnbr=0;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; // 7
//						}
//					}
//				}
//			if (tile_x==3)
//				{
//				comptx=9;brnbr=7;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
//			if (tile_x==4)
//				{
//				comptx=10;brnbr=14;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
//			if (tile_x==5)
//				{
//				comptx=11;brnbr=21;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
				
				for(lecx=0 ; lecx<8; lecx++) // de 0  7, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*lecx;
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				
				for(lecx=8 ; lecx<16; lecx++) // de 8  15, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*(lecx-8);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
					
				for(lecx=16 ; lecx<24; lecx++) // de 16  23, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*(lecx-16);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=24 ; lecx<32; lecx++) // de 24  31, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*(lecx-24);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=32 ; lecx<40; lecx++) // de 32  39, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*(lecx-32);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=40 ; lecx<48; lecx++) // de 40  47, ce qui fait 8
					{
					if (tile_x == 2+lecx)
						{
						comptx = 8+lecx;brnbr = 7*(lecx-40);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
					
					
					
					
				}
			}
		}
	
	
//	if (joystick & JOY_LEFT)
//		{
//		posx-=2;  // direction Gauche
//		if (posx<-28)		posx=-28; // limit va  gauche
//		}
//	if (posx<16 & 
	if (joystick & JOY_LEFT)
		{
		if (pointx>0)
			{
			pointx-=2;
			SCBX(SCBchiffres1) -=2;SCBX(SCBchiffres2) -=2;SCBX(SCBchiffres3) -=2;SCBX(SCBchiffres4) -=2;
		
			col_x-=2;
			if (col_x<1)
				{
				col_x=24;tile_x-=1;
				
			
			
//			if (tile_x==1)
//				{
//				comptx=0;brnbr=0;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
//			if (tile_x==2)
//				{
//				comptx=1;brnbr=7;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
//			if (tile_x==3)
//				{
//				comptx=2;brnbr=14;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
//			if (tile_x==4)
//				{
//				comptx=3;brnbr=21;
//				for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
//					{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//					if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
//						{
//						SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
//						SCBX(&SCB[brnbr][0]) = comptx*24;//16;
//						SCBY(&SCB[brnbr][0]) = compty*24;//16;
//						++brnbr; 
//						}
//					}
//				}
				
				for(lecx=0 ; lecx<8; lecx++) // de 0  7, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*lecx;
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=8 ; lecx<16; lecx++) // de 0  7, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*(lecx-8);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=16 ; lecx<24; lecx++) // de 16  23, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*(lecx-16);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=24 ; lecx<32; lecx++) // de 24  31, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*(lecx-24);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=32 ; lecx<40; lecx++) // de 32  39, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*(lecx-32);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
				for(lecx=40 ; lecx<48; lecx++) // de 40  47, ce qui fait 8
					{
					if (tile_x == 1+lecx)
						{
						comptx = lecx;brnbr = 7*(lecx-40);
						for(compty=0 ; compty<7; compty++) // de 0  6, ce qui fait 7
							{//SCBDATA(&SCB[1][0])  = tmtab[1%10];
							if (level==1)	//SCBDATA(brdata[comptx+(compty*5)]) = brtab[tbr01[compty][comptx]%5];
								{
								SCBDATA(&SCB[brnbr][0])  = tmtab[tbr01[compty][comptx]%10];
								SCBX(&SCB[brnbr][0]) = comptx*24;//16;
								SCBY(&SCB[brnbr][0]) = compty*24;//16;
								++brnbr; // 7
								}
							}
						}
					}
					
					
					
				}
			}	
		}


//	if (joystick & JOY_UP)
//		{
//		posy-=2; // direction Haut
//		if (posy<12)		posy=12; // limit haut
//		}
//	if (posy<34 & pointy>0)
	if (joystick & JOY_UP)
		{
		if (pointy>0)
			{
			pointy-=2;
			SCBY(SCBchiffres1) -=2;SCBY(SCBchiffres2) -=2;SCBY(SCBchiffres3) -=2;SCBY(SCBchiffres4) -=2;
			}
		}

//	if (joystick & JOY_DOWN)
//		{
//		posy+=2; // direction Bas
//		if (posy>128)		{posy=128;} // limit bas
//		}
	if (joystick & JOY_DOWN)
		{
		if (pointy<66)//58)//26)//10
			{
			pointy+=2;
			SCBY(SCBchiffres1) +=2;SCBY(SCBchiffres2) +=2;SCBY(SCBchiffres3) +=2;SCBY(SCBchiffres4) +=2;
			}
		}



	if (joystick & BUTTON_RIGHT)
		{
		if (scaelv<512)	scaelv+=2;
		}
	if (joystick & BUTTON_LEFT)
		{
		if (scaelv>128)	scaelv-=2;
		}
			
	// sprite player
	SCBX(SCBm) = posx+50;SCBY(SCBm) = posy;
	SCBHS(SCBm) = scaelv;SCBVS(SCBm) = scaelv; // taille image originelle = 256
		
	}
		
		
		
		
		
		
//	if (relachright==1)
//		{
//		if (!(joystick & BUTTON_RIGHT))	{relachright=0;}
//		}
//	if (relachright==0)
//		{
//		if (joystick & BUTTON_RIGHT)
//			{
//			++ivrotation;relachright=1;
//			if (ivrotation==3)	ivrotation=1;
//			if (ivrotation==1)
//				{
//				SCBm[0] = 0xe0;  // Determine quadrant --> vertical  l'envers
//				}
//			if (ivrotation==2)
//				{
//				SCBm[0] = 0xf0;  // Determine quadrant --> vertical  l'endroit 
//				}
//			}
//		}


/****************************************************************************************************************************************************/
	

	
	
	

// test positions:
//SCBX(&SCB[1][0]) = 16;//SCBY(&SCB[1][0]) = 0;
//SCBX(&SCB[2][0]) = 32-4;SCBY(&SCB[2][0]) = 8;
//SCBX(&SCB[3][0]) = 42-4;SCBY(&SCB[3][0]) = 18;
//SCBX(&SCB[24][0]) = posx;SCBY(&SCB[24][0]) = posy;

// test: on affecte une autre image:
//SCBDATA(&SCB[1][0])  = tmtab[1%10];
//SCBDATA(&SCB[2][0])  = tmtab[2%10];
//SCBDATA(&SCB[24][0])  = mascot;

//SCB[1][0] = 0xe0;



	//DrawSprite(SCBm);

	voff = pointy; // Set scroll offsets
	hoff = pointx; // Set scroll offsets
   // And now, draw the sprites:
   DrawSprite(init_scb);
   
/************************************************************************** 
**************************************************************************/ 
/** test
 **/  

	atest=tile_x;//brnbr;//pointx;//pointy;//1234;//tile_x;//horszone;//relach;//etape;//SCBCTL0(SCBbr);
	
	// SCBX(SCBpast18) = xpast[18];
	// SCBY(SCBpast18) = ypast[18];

//	atest = SCBX(SCBpast18); //		144
//	atest = SCBY(SCBpast18); //		24
	
//	atest = xpast[18]; //		144
//	atest = ypast[17]; //		
	
	unite = atest % 10;
	dizaine = atest / 10 % 10;
	centaine = atest / 100 % 10;
	millier = atest / 1000 % 10;
//	dizmill = atest / 10000 % 10;
  // unit:  
  SCBDATA(SCBchiffres1) = chiffrestab[unite%14];
//  SCBX(SCBchiffres1) = 100;SCBY(SCBchiffres1) = 68;

  // dizaine:  
  SCBDATA(SCBchiffres2) = chiffrestab[dizaine%14];
//  SCBX(SCBchiffres2) = 92;SCBY(SCBchiffres2) = 68;

  // centaine:  
  SCBDATA(SCBchiffres3) = chiffrestab[centaine%14]; // 0
//  SCBX(SCBchiffres3) = 84;SCBY(SCBchiffres3) = 68;
  
  // millier:  
  SCBDATA(SCBchiffres4) = chiffrestab[millier%14]; // 0
//  SCBX(SCBchiffres4) = 76;
//  SCBY(SCBchiffres4) = 16;

  // dizaine de millier:  
//  SCBDATA(SCBchiffres5) = chiffrestab[dizmill%14]; // 0
//  SCBX(SCBchiffres5) = 68;
//  SCBY(SCBchiffres5) = 16;
  
  //DrawSprite(SCBchiffres1); // Affichage valeur test		  



	Vsync();
if (tempa>0)	--tempa;
if (tempa==0)
	{
	if(joystick & BUTTON_OPTION2)   
		{
		tempa=100;
		SmpStart(ola, 0);
		}
	}
	SwapBuffers();
}
  
/**************************************************************************
**                     FIN de la BOUCLE PRINCIPALE                       **
**************************************************************************/   
  
 }

 